	FUNCTION brent(ax,bx,cx,f,tol,xmin)
	
	implicit none
	
	real*8 ax,bx,cx,f,tol,xmin,brent
	
	integer itmax,iter
	real*8 cgold,zeps,a,b,v,w,x,e,fx,fv,fw,xm,tol1,tol2
	real*8 etemp,d,p,q,r,u,fu
	parameter(itmax=1000,cgold=.3819660d0,zeps=1.d-10)

	external f
!
!---------------------------------------------------------------------------------------
!
	a=min(ax,cx)
	b=max(ax,cx)
	v=bx
	w=v
	x=v
	e=0.d0
	fx=f(x)
	fv=fx
	fw=fx
	do iter=1,itmax
	  xm=0.5d0*(a+b)
	  tol1=tol*dabs(x)+zeps
	  tol2=tol1+tol1
	  if(dabs(x-xm) .LE. (tol2-.5d0*(b-a))) GOTO 3
	  if(dabs(e) .GT. tol1) then
	    r=(x-w)*(fx-fv)
	    q=(x-v)*(fx-fw)
	    p=(x-v)*q-(x-w)*r
	    q=q+q-r-r
	    if(q .GT. 0.d0) p=-p
	    q=dabs(q)
	    etemp=e
	    e=d
	    if(dabs(p) .GE. dabs(.5d0*q*etemp) .OR. p .LE. q*(a-x) &
      	    .OR. p .GE. q*(b-x)) GOTO 1
	    d=p/q
	    u=x+d
	    if(u-a .LT. tol2 .OR. b-u .LT. tol2) d = dsign(tol1,xm-x)
	    GOTO 2
	  endif
1	  if(x .GE. xm) then
	    e=a-x
	  else
	    e=b-x
	  endif
	  d=cgold*e
2	  if(dabs(d) .GE. tol1) then
	    u=x+d
	  else
	    u=x+dsign(tol1,d)
	  endif
	  fu=f(u)
	  if(fu .LE. fx)then
	    if(u .GE. x) then
	      a=x
	    else
	      b=x
	    endif
	    v=w
	    fv=fw
	    w=x
	    fw=fx
	    x=u
	    fx=fu
	  else
	    if(u .LT. x) then
	      a=u
	    else
	      b=u
	    endif
	    if(fu .LE. fw .OR. w .EQ. x) then
	      v=w
	      fv=fw
	      w=u
	      fw=fu
	    else if(fu .LE. fv .OR. v .EQ. x .OR. v .EQ. w) then
	      v=u
	      fv=fu
	    endif
	  endif
	enddo
	PAUSE 'Brent exceeded max iter'
3	xmin=x
	BRENT=fx
	RETURN
	END
