	FUNCTION DBRENT(ax,bx,cx,f,df,tol,xmin)
	
	implicit none
	
	real*8 ax,bx,cx,f,df,tol,xmin,DBRENT
	
	integer itmax
	real*8 zeps
	parameter(itmax=1000,zeps=1.d-10)
	
	integer iter
	real*8 a,b,v,w,x,d,e,olde,fx,fv,fw,dx,dv,dw,xm
	real*8 d1,d2,du,fu,u1,u2,tol1,tol2,u
	logical ok1, ok2
	
	external f, df
!
!----------------------------------------------------------------------
!
	a=min(ax,cx)
	b=max(ax,cx)
	v=bx
	w=v
	x=v
	e=0.d0
	fx=f(x)
	fv=fx
	fw=fx
	dx=df(x)
	dv=dx
	dw=dx
	do iter=1,itmax
	  xm=0.5d0*(a+b)
	  tol1=tol*dabs(x)+zeps
	  tol2=tol1+tol1
	  if(dabs(x-xm) .LE. (tol2-.5d0*(b-a))) GOTO 3
	  if(dabs(e) .GT. tol1) then
	    d1=b+b-a-a
	    d2=d1
	    if(dw .NE. dx) d1=(w-x)*dx/(dx-dw)
	    if(dv .NE. dx) d2=(v-x)*dx/(dx-dv)
	    u1=x+d1
	    u2=x+d2
	    ok1=((a-u1)*(u1-b) .GT. 0.d0) .AND. (dx*d1 .LE. 0.d0)
	    ok2=((a-u2)*(u2-b) .GT. 0.d0) .AND. (dx*d2 .LE. 0.d0)
	    olde=e
	    e=d
	    if(.NOT. (ok1 .OR. ok2)) then
	      GOTO 1
	    else if (ok1 .AND. ok2) then
	      if(dabs(d1) .LT. dabs(d2)) then
	        d=d1
	      else
	        d=d2
	      endif
 	    else if(ok1) then
	      d=d1
	    else
	      d=d2
	    endif
	    if(dabs(d) .GT. dabs(.5d0*olde)) GOTO 1
	    u=x+d
	    if(u-a .LT. tol2 .OR. b-u .LT. tol2) d=dsign(tol1,xm-x)
	    GOTO 2
	  endif
1	  if(dx .GE. 0.d0) then
	    e=a-x
	  else
	    e=b-x
	  endif
	  d=0.5d0*e
2	  if(dabs(d) .GE. tol1) then
	    u=x+d
	    fu=f(u)
	  else
	    u=x+dsign(tol1,d)
	    fu=f(u)
	    if(fu .GT. fx) GOTO 3
	  endif
	  du=df(u)
	  if(fu .LE. fx) then
	    if(u .GE. x) then
	      a=x
	    else
	      b=x
	    endif
	    v=w
	    fv=fw
	    dv=dw
	    w=x 
	    fw=fx
	    dw=dx
	    x=u
	    fx=fu
	    dx=du
	  else
	    if(u .LT. x) then
	      a=u
	    else
	      b=u
	    endif
	    if(fu .LE. fw .OR. w .EQ. x) then
	      v=w
	      fv=fw
	      dv=dw
	      w=u
	      fw=fu
	      dw=du
	    else if(fu .LE. fv .OR. v .EQ. x .OR. v.EQ. w) then
	      v=u
	      fv=fu
	      dv=du
	    endif
	  endif
	enddo
	Print*, 'DBRENT exceeded max iter'
	write(2,*) 'DBRENT exceeded max iter'
!	PAUSE 'DBRENT exceeded max iter'
3	xmin=x
	DBRENT=fx
	
	RETURN
	END
