FUNCTION Upot(point,iconf,num)

implicit none

! Parameters

integer	::	iconf,maxmc,maxsu,maxat,maxpar,nmax
parameter(maxmc=11,maxsu=20,maxat=maxmc+maxsu,maxpar=30,nmax=30)
integer	::	maxbond,maxang,maxattyp,maxpair,maxconf
parameter(maxbond=5,maxang=15,maxattyp=3,maxpair=10,maxconf=30)

! Global variables

integer	::	num
integer	::	idmc(maxmc),idsu(maxsu)
integer	::	mctsu(maxsu),sutmc(maxsu)
integer	::	nangskel,nangtot,ndof,nall
integer	::	natmc,natsu
integer	::	nbond,nang,nattyp,npair
integer	::	bondtype(maxattyp,maxattyp),angletype(maxattyp,maxattyp,maxattyp)
integer	::	pairtype(maxattyp,maxattyp)
real*8	::	point(nmax),Upot
real*8	::	bl(maxmc-1),b(maxmc-1,3),dl(maxmc-1),d(maxmc-1,3)
real*8	::	xmc(maxmc),ymc(maxmc),zmc(maxmc)
real*8	::	xsu(maxsu),ysu(maxsu),zsu(maxsu)
real*8	::	blen(maxbond),theta0(maxang),kthet(maxang),kdih(maxbond)
real*8	::	sig(maxpair),eps(maxpair)
real*8	::	stor(nmax)

! Local variables

integer	::	i,j, k, l, m, n
real*8	::	angle,bngle,cngle,length,dummy,tmp
real*8	::	sinthip1,costhip1,cosphi,sinphi,n1(3),n2(3)
real*8	::	dx,dy,dz,rij2,ri6
real*8	::	mrgpnt(nmax), pi,twopi, VeryBig
parameter(pi=3.14159265359d0,twopi=pi+pi, VeryBig=1.d+10)
real*4	::	ran
real*8	::	C(maxpar,maxconf)

common	/lim/	nangskel,nangtot,ndof,nall
common	/bnd/	b,bl,d,dl
common	/at1/	natmc,natsu
common	/at2/	idmc,idsu
common	/at3/	xmc,xsu,ymc,ysu,zmc,zsu
common	/ff1/	nbond,nang,nattyp,npair
common	/ff2/	bondtype,angletype,pairtype
common	/ff3/	blen,theta0,kthet,kdih,sig,eps
common	/con/	mctsu,sutmc
common	/str/	stor
common	/cof/	C
!
!-----------------------------------------------------------------------------------
!
	
	Upot = dot_product(C(iconf,1:num),point(1:num))
	RETURN

!	Rest of the lines not necessary

!	Restore useful values

	mrgpnt(1:num) = point(1:num)
	mrgpnt(num+1:nall)=stor(num+1:nall)

!	Now, the molecule has to be re-built. The new-built molecule
!	will never be identical to the original, however, since real bond lengths
!	do not exactly match blen. This is a price to pay for using constant
!	bond length model. 

!	First, build main chain

	xmc(1:natmc)=0.d0; ymc(1:natmc)=0.d0; zmc(1:natmc)=0.d0
	xsu(1:natsu)=0.d0; ysu(1:natsu)=0.d0; zsu(1:natsu)=0.d0
	xmc(2)=blen(bondtype(idmc(1),idmc(2)))
	length=blen(bondtype(idmc(2),idmc(3)))
	angle=mrgpnt(1)
	xmc(3)=xmc(2)+length*dcos(angle); ymc(3)=length*dsin(angle)
	CALL abc1d(xmc(1:2),ymc(1:2),zmc(1:2),b(1,1:3),bl(1))
	CALL abc1d(xmc(2:3),ymc(2:3),zmc(2:3),b(2,1:3),bl(2))
	Do i=1,natmc-3 
	  CALL uXv1(b(i,:),b(i+1,:),n1,dummy)
	  sinthip1 = dsin(mrgpnt(i+1))
	  CALL uxv1(n1,b(i+1,:),n2,dummy)
	  costhip1=dcos(mrgpnt(i+1))
	  cosphi=dcos(mrgpnt(nangtot+i)); sinphi=dsin(mrgpnt(nangtot+i))
	  bl(i+2)=blen(bondtype(idmc(i+2),idmc(i+3)))
	  b(i+2,:)=-b(i+1,:)*bl(i+2)*costhip1+n1(:)*bl(i+2)*sinthip1*sinphi &
	           +n2(:)*bl(i+2)*sinthip1*cosphi
	  xmc(i+3)=xmc(i+2)+b(i+2,1)
	  ymc(i+3)=ymc(i+2)+b(i+2,2)
	  zmc(i+3)=zmc(i+2)+b(i+2,3)
	End Do
	
!	Then, build pendant groups
	
	Do i=1,natsu
	  j=sutmc(i)
	  length=blen(bondtype(idsu(i),idmc(j)))
	  angle=mrgpnt(nangskel+i+i-1)
	  d(i,1)=length*dcos(angle)
	  bngle=mrgpnt(nangskel+i+i)
	  cngle=mrgpnt(j-1)
	  d(i,2)=length*(dcos(bngle)-dcos(angle)*dcos(cngle))/dsin(cngle)
	  tmp=length**2-d(i,1)**2-d(i,2)**2
	  if(tmp<0.d0) then
!		write(*,*) 'Pendant:',i,' skel:',j
!		write(*,*) 'types:', idsu(i),idmc(j)
!		write(*,*) 'bond length',length,d(i,1),d(i,2)
!		print*, 'point:',mrgpnt(1:num)*180.d0/pi
		CALL random_number(ran)
		Upot=VeryBig*(1.+ran); write(*,*) 'Pot nrg =    VERY BIG'; RETURN
!		Pause
	  endif
	  d(i,3)=(-1)**(i+1)*dsqrt(tmp)
	  xsu(i)=xmc(j)+d(i,1); ysu(i)=ymc(j)+d(i,2); zsu(i)=zmc(j)+d(i,3)
	End do

!	Upot = sum(dabs(point(1:num)-stor(1:num))) ! just a test...
!	RETURN

!	Calculate potential energy; maybe only calculate its varying part.
!	No need to compute components that remain invariant due to constraints,
!	hence the exit commands - commented out; I prefer to know the whole energy

	Upot = 0.d0; k=0
	Do i=1,natmc-2
!		k=k+1; if(k>num) exit
		j=angletype(idmc(i),idmc(i+1),idmc(i+2))
		Upot = Upot+.5d0*Kthet(j)*(mrgpnt(i)-Theta0(j))**2
	End Do

	Do i=1,natsu
		j=sutmc(i)
!		k=k+1; if(k>num) exit
		l=angletype(idmc(j-1),idmc(j),idsu(i))
		Upot = Upot+.5d0*Kthet(l)*(mrgpnt(nangskel+i+i-1)-Theta0(l))**2
!		k=k+1; if(k>num) exit
		l=angletype(idmc(j+1),idmc(j),idsu(i))
		Upot = Upot+.5d0*Kthet(l)*(mrgpnt(nangskel+i+i)-Theta0(l))**2
	End Do

	Do i=2,natmc-2
!		k=k+1; if(k>num) exit
		Upot = Upot+.5d0*Kdih(bondtype(idmc(i),idmc(i+1)))*(1.d0+dcos(3.d0*mrgpnt(nangtot+i)))
		Upot = Upot+.15d0*Kdih(bondtype(idmc(i),idmc(i+1)))*(1.d0+dcos(6.d0*mrgpnt(nangtot+i)))
	End Do

!	Include contribution from RSiR angles so as to retain symmetry (see my notes)
!	No exit command here. Always compute them, since they are in general affected
!	by changes in dof*s, which implies that the angles themselves have to be reeavaluated
!	each time. The pendant bond unit vectors are required to this purpose.

	Do i=1,natsu
	  d(i,1)=xsu(i)-xmc(sutmc(i))
	  d(i,2)=ysu(i)-ymc(sutmc(i))
	  d(i,3)=zsu(i)-zmc(sutmc(i))
	
	  dl(i)=dsqrt(dot_product(d(i,1:3),d(i,1:3)))
	
	  d(i,:)=d(i,:)/dl(i)
	End Do

	k=0
	Do i=2,natmc-1
	  j=mctsu(i)
	  if(j /= 0) then
	    angle=dacos(dot_product(d(j,:),d(j-1,:)))
	    k=k+1
	    stor(ndof+k)=angle
	  endif
	EndDo
	mrgpnt(ndof+1:nall)=stor(ndof+1:nall)

	Do i=2,natsu,2
		j=sutmc(i)
		l=angletype(idsu(i-1),idmc(j),idsu(i))
		Upot = Upot+.5d0*Kthet(l)*(mrgpnt(ndof+1)-Theta0(l))**2
	End Do

!	Finally, add Lennard-Jones terms; no exit command here either.

	Do i=1,natmc-3
		Do j=i+3,natmc
			k=pairtype(idmc(i),idmc(j))
			dx=xmc(j)-xmc(i)
			dy=ymc(j)-ymc(i)
			dz=zmc(j)-zmc(i)
			rij2=dx*dx+dy*dy+dz*dz
			ri6=(sig(k)**2/rij2)**3
			Upot=Upot+4.d0*eps(k)*ri6*(ri6-1.d0)
		End Do
	End Do	

	Do i=1,natsu-1
		Do j=i+1,natsu
			l=sutmc(i); m=sutmc(j)
			if(l < m) then
				k=pairtype(idsu(j),idsu(j))
				dx=xsu(j)-xsu(i)
				dy=ysu(j)-ysu(i)
				dz=zsu(j)-zsu(i)
				rij2=dx*dx+dy*dy+dz*dz
				ri6=(sig(k)**2/rij2)**3
				Upot=Upot+4.d0*eps(k)*ri6*(ri6-1.d0)
			end if
		end do
	end do

	Do i=1,natmc
		Do j=1,natsu
			if(iabs(sutmc(j)-i) > 1) then
				k = pairtype(idmc(i),idsu(j))
				dx=xsu(j)-xmc(i)
				dy=ysu(j)-ymc(i)
				dz=zsu(j)-zmc(i)
				rij2=dx*dx+dy*dy+dz*dz
				ri6=(sig(k)**2/rij2)**3
				Upot=Upot+4.d0*eps(k)*ri6*(ri6-1.d0)
			end if
		end do
	end do
	write(*,*) 'Pot nrg =', Upot
				
RETURN
End Function Upot
