PROGRAM aaamainFRPRMN

implicit none

integer	::	i,j,k,l,m,n,nmax,iter,iconf
integer	::	nbond,nang,nattyp,npair,nconf,npar
integer	::	maxbond,maxang,maxattyp,maxpair,maxconf
parameter(maxbond=5,maxang=15,maxattyp=3,maxpair=10,maxconf=30)
integer	::	natmc,natsu
integer	::	maxmc,maxsu,maxat,maxpar
parameter(maxmc=11,maxsu=20,maxat=maxmc+maxsu,maxpar=16)
integer	::	bondtype(maxattyp,maxattyp),angletype(maxattyp,maxattyp,maxattyp)
integer	::	pairtype(maxattyp,maxattyp)
integer	::	idmc(maxmc,maxconf),idsu(maxsu,maxconf)
integer	::	mctsu(maxsu),sutmc(maxsu)
integer	::	numbond(5),numang(15), numpair(15)
integer	::	nangskel,nangtot,ndof,ntot,nall
integer	::	iopt
real*8	::	lambda, ftol, pi, deg2rad, rad2deg
parameter(nmax=20, pi=3.14159265359d0,deg2rad=pi/180.d0,rad2deg=180.d0/pi,ftol = 0.00000001d0)
real*8	::	point(nmax)
real*8	::	TestF,xi(nmax,nmax),fret
real*8	::	blen(maxbond),theta0(maxang),kthet(maxang),kdih(maxbond)
real*8	::	sigat(maxattyp),epsat(maxattyp)
real*8	::	sig(maxpair),eps(maxpair)
real*8	::	xmc(maxmc,maxconf),ymc(maxmc,maxconf),zmc(maxmc,maxconf)
real*8	::	xsu(maxsu,maxconf),ysu(maxsu,maxconf),zsu(maxsu,maxconf)
real*8	::	alen(maxbond),angle,bngle,cngle
real*8	::	bl(maxmc-1,maxconf),b(maxmc-1,maxconf,3),dl(maxmc-1,maxconf),d(maxmc-1,maxconf,3)
real*8	::	theta(maxang,maxconf,maxang),phi(maxbond,maxconf),tau1(maxconf),tau2(maxconf)
real*8	::	VMP2(maxconf)
real*8	::	n1(3),n2(3)
real*8	::	stor(nmax),ranum(maxang),fprev,angle0(maxang)
real*8	::	length,dummy, x, y, z,dx,dy,dz,rij2
real*8	::	sinthip1,costhip1,cosphi,sinphi
real*8	::	r6(maxpair,maxconf,maxat*(maxat-1)/2),r12(maxpair,maxconf,maxat*(maxat-1)/2)
real*8	::	C(maxpar,maxconf),Cbak(maxpar,maxconf),sumsqv2
real*8	::	drvs(maxpar),prsnt(1:maxpar)

character*22	::	label
character*7		::	sffx

common	/ff1/	nbond,nang,nattyp,npair,npar
common	/ff2/	bondtype,angletype,pairtype
common	/ff3/	blen,theta0,kthet,kdih,sig,eps

common	/at1/	natmc,natsu,nconf
common	/at2/	idmc,idsu
common	/at3/	xmc,xsu,ymc,ysu,zmc,zsu
	
common	/con/	mctsu,sutmc
	
common	/str/	stor

common	/lim/	nangskel,nangtot,ndof,ntot,nall

common	/bnd/	b,bl,d,dl

common	/ang/	theta

common	/dih/	phi

common	/rij/	r6, r12

common	/cof/	C

common	/ene/	VMP2

common	/drv/	drvs

common	/opt/	iopt

external	TestF

!------------------------------------------------------------------------
!	Initialize
	
	point=-10000000.d0; theta=0.d0; b=0.d0; d=0.d0; bl=0.d0; dl=0.d0; r6(:,:,:)=0.d0; r12(:,:,:)=0.d0

!	Read  force-field parameters and Cartesian coordinates
!	Constant bond length model. We ll test it for various bond lengths
	
	print*, 'output file name suffix?'
	read(*,*) sffx
1	open(unit=1,file='p2monomer.in')
	read(1,*) npar	! well, this is useless
	read(1,*) nbond
	read(1,*) (blen(i),i=1,nbond)
	read(1,*) nang
	read(1,*)
	read(1,*) (theta0(i),i=1,nang)
	theta0=theta0*pi/180.d0
	read(1,*) (kthet(i),i=1,nang)
	read(1,*) (kdih(i),i=1,nbond)
	read(1,*) nattyp,npair
	read(1,*) (sigat(i),i=1,nattyp)
	read(1,*) (epsat(i),i=1,nattyp)
	read(1,*) nbond	!	each time carries different meaning
    do i = 1, nbond
       READ (1,*) n,j,k
       bondtype(j,k) = n
    enddo
	nbond = n
	read(1,*) nang
    do i = 1, nang
       READ (1,*) n,j,k,l
       angletype(j,k,l) = n
    enddo
	nang = n
    do i = 1, npair
       READ (1,*) n,j,k
       pairtype(j,k) = n
 	   sig(n)=.5d0*(sigat(j)+sigat(k))
	   eps(n)=dsqrt(epsat(j)*epsat(k))
    enddo
	read(1,*) nbond, nang, npair	! reread values actually of interest for the specific molecule

!	Store them in the point to optimise

	Do i=1,npair
		point(2*i-1)=4.d0*eps(i)*sig(i)**6
		point(2*i  )=4.d0*eps(i)*sig(i)**12
	End Do
	k=2*npair
	point(k+1:k+nbond)=kdih(1:nbond)
	k=k+nbond
	point(k+1:k+nang)=kthet(1:nang)
	k=k+nang
	ntot=k
	point(k+1:k+nang)=theta0(1:nang)
	nall=k+nang
	stor(1:nall)=point(1:nall)

	read(1,*)
	read(1,*) natmc,natsu

!	Connectivities

	j=max(natmc,natsu)
	Do i=1,j
	  read(1,*) mctsu(i),sutmc(i)
	End Do

	read(1,*) nconf

	Do j=1,nconf
		Read(1,*) VMP2(j)
		Read(1,*) phi(1,j),phi(2,j)
		Do i=1,natmc
			read(1,*) l,k,x,y,z 
			idmc(l,j)=k; xmc(l,j)=x; ymc(l,j)=y; zmc(l,j)=z
		End Do
		Do i=1,natsu
			read(1,*) l,k,x,y,z 
			idsu(l,j)=k; xsu(l,j)=x; ysu(l,j)=y; zsu(l,j)=z
		End Do
	End Do

	close(1)
	dummy=VMP2(1)
	VMP2(1:nconf)=VMP2(1:nconf)-dummy
	sumsqv2 = dot_product(VMP2(1:nconf),VMP2(1:nconf))
	
!	Now, use Cartesian to calculate internal coordinates. 

!	First, form unit bond vectors

	Do iconf=1,nconf
		Do i=1,natmc-1
			CALL abc1d(xmc(i:i+1,iconf),ymc(i:i+1,iconf),zmc(i:i+1,iconf),b(i,iconf,1:3),bl(i,iconf))
		End Do
	
		Do i=1,natsu
			d(i,iconf,1)=xsu(i,iconf)-xmc(sutmc(i),iconf)
			d(i,iconf,2)=ysu(i,iconf)-ymc(sutmc(i),iconf)
			d(i,iconf,3)=zsu(i,iconf)-zmc(sutmc(i),iconf)
	
			dl(i,iconf)=dsqrt(dot_product(d(i,iconf,1:3),d(i,iconf,1:3)))
	
			d(i,iconf,:)=d(i,iconf,:)/dl(i,iconf)
		End Do
	End Do

!	Next is optional; we set constant blen equal to average of real lengths

!	goto 2	
	numbond(:)=0; alen(:)=0.d0
	Do iconf=1,nconf
		Do i=1,natmc-1
			n=bondtype(idmc(i,iconf),idmc(i+1,iconf))
			alen(n)=alen(n)+bl(i,iconf)
			numbond(n)=numbond(n)+1
		End Do
		Do i=1,natsu
			n=bondtype(idsu(i,iconf),idmc(sutmc(i),iconf))
			alen(n)=alen(n)+dl(i,iconf)
			numbond(n)=numbond(n)+1
		End Do
		WRITE(11,31) (bl(i,iconf),i=1,natmc-1),(dl(i,iconf),i=1,natsu)
	End do
	Do i=1,nbond
	  if(numbond(i)/=0) then
		alen(i)=alen(i)/numbond(i)
		write(2,22) i,blen(i),alen(i)
	  end if
	End Do
!	blen=alen

31	format(<natmc+natsu-1>(3x,f8.5))
22	format('Input bond length ',2x,i2,2x,' = ',2x,f6.4,2x,' calculated = ',2x,f6.4)
	
!	Now, calculate bond angles

2	continue

	Do iconf=1,nconf
		numang(:)=0
		Do i=1,natmc-2
			k=k+1
			j=angletype(idmc(i,iconf),idmc(i+1,iconf),idmc(i+2,iconf))
			numang(j)=numang(j)+1
			theta(j,iconf,numang(j))=dacos(dot_product(-b(i,iconf,:),b(i+1,iconf,:)))
		End do
!
		Do i=1,natmc-2
			j=mctsu(i+1)
			if(j /= 0) then
				l=angletype(idmc(i,iconf),idmc(i+1,iconf),idsu(j-1,iconf))
				numang(l)=numang(l)+1
				theta(l,iconf,numang(l))=dacos(dot_product(-b(i,iconf,:),d(j-1,iconf,:)))
			end if
		End Do

		Do i=1,natmc-2
			j=mctsu(i+1)
			if(j /= 0) then
				l=angletype(idmc(i+2,iconf),idmc(i+1,iconf),idsu(j-1,iconf))
				numang(l)=numang(l)+1
				theta(l,iconf,numang(l))=dacos(dot_product(b(i+1,iconf,:),d(j-1,iconf,:)))
			end if
		End Do

		Do i=1,natmc-2
			j=mctsu(i+1)
			if(j /= 0) then
				l=angletype(idmc(i,iconf),idmc(i+1,iconf),idsu(j,iconf))
				numang(l)=numang(l)+1
				theta(l,iconf,numang(l))=dacos(dot_product(-b(i,iconf,:),d(j,iconf,:)))
			end if
		End Do

		Do i=1,natmc-2
			j=mctsu(i+1)
			if(j /= 0) then
				l=angletype(idmc(i+2,iconf),idmc(i+1,iconf),idsu(j,iconf))
				numang(l)=numang(l)+1
				theta(l,iconf,numang(l))=dacos(dot_product(b(i+1,iconf,:),d(j,iconf,:)))
			end if
		End Do
!
!		No need to calculate dihedrals; I read them from input file
!
!		Also, calculate non-dof bond angles.
	
		Do i=2,natmc-1
			j=mctsu(i)
			if(j /= 0) then
				l=angletype(idsu(j-1,iconf),idmc(i,iconf),idsu(j,iconf))
				numang(l)=numang(l)+1
				theta(l,iconf,numang(l))=dacos(dot_product(d(j,iconf,:),d(j-1,iconf,:)))
			endif
		EndDo

!		Finally, calculate inverse distance powers useful in calculating Lennard-Jones energy
		
		numpair(:)=0
		Do i=1,natmc-3
			Do j=i+3,natmc
				k=pairtype(idmc(i,iconf),idmc(j,iconf)); numpair(k)=numpair(k)+1
				dx=xmc(j,iconf)-xmc(i,iconf)
				dy=ymc(j,iconf)-ymc(i,iconf)
				dz=zmc(j,iconf)-zmc(i,iconf)
				rij2=dx*dx+dy*dy+dz*dz
				r6(k,iconf,numpair(k))=1.d0/rij2**3
				r12(k,iconf,numpair(k))=1.d0/rij2**6
			End Do
		End Do	
		
		Do i=1,natsu-1
			Do j=i+1,natsu
				l=sutmc(i); m=sutmc(j)
				if(l < m) then
					k=pairtype(idsu(j,iconf),idsu(j,iconf)); numpair(k)=numpair(k)+1
					dx=xsu(j,iconf)-xsu(i,iconf)
					dy=ysu(j,iconf)-ysu(i,iconf)
					dz=zsu(j,iconf)-zsu(i,iconf)
					rij2=dx*dx+dy*dy+dz*dz
					r6(k,iconf,numpair(k))=1.d0/rij2**3
					r12(k,iconf,numpair(k))=1.d0/rij2**6
				end if
			end do
		end do
		
		Do i=1,natmc
			Do j=1,natsu
				if(iabs(sutmc(j)-i) > 1) then
					k = pairtype(idmc(i,iconf),idsu(j,iconf)); numpair(k)=numpair(k)+1
					dx=xsu(j,iconf)-xmc(i,iconf)
					dy=ysu(j,iconf)-ymc(i,iconf)
					dz=zsu(j,iconf)-zmc(i,iconf)
					rij2=dx*dx+dy*dy+dz*dz
					r6(k,iconf,numpair(k))=1.d0/rij2**3
					r12(k,iconf,numpair(k))=1.d0/rij2**6
				end if
			end do
		end do
		
	End Do

!	Now, let*s calculate some coefficients useful in finding the potential energy,
!	as well as the objective function and its derivatives with respect to the 
!	force-field parameters.
	
	C = 0.d0
	Do i=1,nconf

		j=0
 inner:	Do k=1,npair
			j=j+1; C(j,i) = -sum(r6(k,i,1:numpair(k))) 
			j=j+1; C(j,i) =  sum(r12(k,i,1:numpair(k)))
		End Do inner
		j=2*npair
		forall(k=j+1:j+nbond) C(k,i) = .5d0*(1.d0+dcos(3.d0*phi(k-j,i)*deg2rad))
		j=j+nbond
		forall(k=j+1:j+nang) C(k,i) = .5d0*sum((theta(k-j,i,1:numang(k-j))-theta0(k-j))**2)
!		j=j+nbond
!		forall(k=j+1:j+nbond) C(k,i) = &
!		.5d0*sum(((bl(k,i,:)-blen(k)))**2) + &
!		.5d0*sum(((dl(k,i,:)-blen(k)))**2)

	End Do
	Cbak = C

!	write initial point

	prsnt(1:nall)=point(1:nall)
	Do i=1,npair
		prsnt(2*i-1)=(point(2*i)/point(2*i-1))**0.166666666d0
		prsnt(2*i  )=point(2*i-1)**2/point(2*i)/4.d0
	End Do

	open(unit=2, file='results.'//sffx)
	write(2,*)
	write(2,*) ' Initial point'
	write(2,102) TestF(prsnt,nall)
	write(2,123) prsnt(1:ntot),prsnt(ntot+1:nall)*rad2deg
	CALL dfunc(nall,point,drvs)
	write(2,123) drvs(1:nall)
	write(2,*)	

!	Now, we are ready to proceed in the optimisation
!	First initialise input to the FRPRMN
	
11	point(1:nall)=stor(1:nall)
	iter=0
	C = Cbak ! restore coefficients if come back here, because some C*s have been altered in TestF
	print*, 'number of dimensions? (less than 20)'
	read(*,*) n
	if(n==0) then
		close(2)
		STOP
	endif
	
!	point(1:n) = stor(1:n)
	
	fprev=10000.d0; l=0

12	if(n<=ntot) then
		print*, 'Test various equil angles chosen at random? 1 = yes, 0 = no'
		read(*,*) iopt
	endif

	if(iopt==0) then
	
		C = Cbak ! restore coefficients if come back here, because some C*s have been altered in TestF
		CALL frprmn(point,n,ftol,iter,fret) ! ;stop
		l=l+1
		fret=fret/sumsqv2

		prsnt(1:nall)=point(1:nall)
		Do i=1,npair
			prsnt(2*i-1)=(point(2*i)/point(2*i-1))**0.166666666d0
			prsnt(2*i  )=point(2*i-1)**2/point(2*i)/4.d0
		End Do
		prsnt(ntot+1:nall)=prsnt(ntot+1:nall)*rad2deg

		write(*,200) dfloat(l); 	write(2,200)  dfloat(l)
		write(*,112) iter, fret, dsqrt(fret)/dfloat(nconf)
		write(*,122) angle0(1:nang)/deg2rad
		write(*,113) prsnt(1:n)
		write(*,*)
		write(*,113) drvs(1:n)
		write(*,*)
		write(*,*)
		write(2,*)
		write(2,*) ' Optimised'
		write(2,110)  n
		write(2,112) iter, fret, dsqrt(fret)/dfloat(nconf)
		write(2,122) angle0(1:nang)/deg2rad
		write(2,113) prsnt(1:n)
		write(2,113) drvs(1:n)

		fprev = fret

	else if(iopt==1) then

		DO 

			point(1:nall)=stor(1:nall)
			C = Cbak ! restore coefficients if come back here, because some C*s have been altered in TestF
			Do i=1,nang
				call random_number(ranum(i))
				angle0(i)=theta0(i)-(2.*ranum(i)-1.)*10.d0*deg2rad
				k=npair+npair+nbond+i
				Do iconf=1,nconf
					C(k,iconf) = .5d0*sum((theta(i,iconf,1:numang(i))-angle0(i))**2)
				End Do
			end do
	
			CALL frprmn(point,n,ftol,iter,fret) ! ;stop
			l=l+1
			fret=fret/sumsqv2

			if(fret < fprev     .AND. all(point(1:n)-.1d0*stor(1:n)>0.d0)) then
!			if(fret < 0.0015d0  .AND. all(point(1:n)-.1d0*stor(1:n)>0.d0)) then
!			if(fret < 0.00068d0 .OR.  fret < fprev) then
!			if(fret < fprev) then
		
				prsnt(1:ntot)=point(1:ntot)
				prsnt(ntot+1:nall)=angle0(1:nang)
				Do i=1,npair
					prsnt(2*i-1)=(point(2*i)/point(2*i-1))**0.166666666d0
					prsnt(2*i  )=point(2*i-1)**2/point(2*i)/4.d0
				End Do
				prsnt(ntot+1:nall)=prsnt(ntot+1:nall)*rad2deg

				write(*,200) dfloat(l); 	write(2,200)  dfloat(l)
				write(*,112) iter, fret, dsqrt(fret)/dfloat(nconf)
!				write(*,122) angle0(1:nang)/deg2rad
				write(*,113) prsnt(1:n)
				write(*,*)
				write(*,113) drvs(1:n)
				write(*,*)
				write(*,*)
				write(2,*)
				write(2,*) ' Optimised'
				write(2,110)  n
				write(2,112) iter, fret, dsqrt(fret)/dfloat(nconf)
!				write(2,122) angle0(1:nang)/deg2rad
				write(2,123) prsnt(1:nall)
				write(2,123) drvs(1:nall)
				Do i=1,nconf
				dummy=dot_product(C(1:ntot,i),point(1:ntot))
				write(2,222) VMP2(i),dummy,dummy-VMP2(i)
				End Do

				fprev = fret

			end if

		END DO

	else

		goto 12

	endif

	goto 11

110	format('Parameters to optimise = ',2x,i2)
111	format(<n+1>(f7.2,1x))
112	format(' Iterations :',2x,i6,2x,' Optimised Objective Function (weighted):',2x,f8.5, &
          /'sqrt(Fweighted)/Nconf :',2x,f8.5)
102	format(' Objective Function (weighted):',2x,f8.5)
113 format(<n>(f9.3,1x))
114 format(<ndof-nangtot>(f7.2,1x))
115 format(<nall-ndof>(f7.2,1x))
122 format(<nang>(f9.3,1x))
123 format(<nall>(f9.3,1x))
200	format(d8.2)
222	format(3(3x,f8.5))
	
END PROGRAM aaamainFRPRMN